(window.webpackJsonp=window.webpackJsonp||[]).push([[238],{292:function(e,n,t){"use strict";t.r(n),t.d(n,"frontMatter",(function(){return s})),t.d(n,"metadata",(function(){return r})),t.d(n,"rightToc",(function(){return p})),t.d(n,"default",(function(){return b}));var a=t(2),i=t(6),o=(t(0),t(305)),s={title:"Routing"},r={unversionedId:"routing",id:"routing",isDocsHomePage:!1,title:"Routing",description:"App routing",source:"@site/docs/routing.md",slug:"/routing",permalink:"/wave/docs/routing",editUrl:"https://github.com/h2oai/wave/edit/master/website/docs/routing.md",version:"current",sidebar:"someSidebar",previous:{title:"State",permalink:"/wave/docs/state"},next:{title:"Realtime Sync",permalink:"/wave/docs/realtime"}},p=[{value:"App routing",id:"app-routing",children:[]},{value:"Hash routing",id:"hash-routing",children:[{value:"Setting the location hash",id:"setting-the-location-hash",children:[]},{value:"Getting the location hash",id:"getting-the-location-hash",children:[]},{value:"Hash route switching",id:"hash-route-switching",children:[]},{value:"Organizing code",id:"organizing-code",children:[]},{value:"Reducing boilerplate",id:"reducing-boilerplate",children:[]},{value:"Pattern matching",id:"pattern-matching",children:[]}]}],c={rightToc:p};function b(e){var n=e.components,t=Object(i.a)(e,["components"]);return Object(o.b)("wrapper",Object(a.a)({},c,t,{components:n,mdxType:"MDXLayout"}),Object(o.b)("h2",{id:"app-routing"},"App routing"),Object(o.b)("p",null,"Your Wave app gets hosted at the route you passed to ",Object(o.b)("inlineCode",{parentName:"p"},"@app()"),"."),Object(o.b)("pre",null,Object(o.b)("code",Object(a.a)({parentName:"pre"},{className:"language-py",metastring:"{3}","{3}":!0}),"from h2o_wave import Q, main, app\n\n@app('/foo')\nasync def serve(q: Q):\n    pass\n")),Object(o.b)("p",null,"To host your app at ",Object(o.b)("inlineCode",{parentName:"p"},"localhost:10101/foo")," or ",Object(o.b)("inlineCode",{parentName:"p"},"www.example.com/foo"),", pass ",Object(o.b)("inlineCode",{parentName:"p"},"/foo")," to ",Object(o.b)("inlineCode",{parentName:"p"},"@app()"),"."),Object(o.b)("p",null,"To host your app at ",Object(o.b)("inlineCode",{parentName:"p"},"localhost:10101")," or ",Object(o.b)("inlineCode",{parentName:"p"},"www.example.com"),", pass ",Object(o.b)("inlineCode",{parentName:"p"},"/")," to ",Object(o.b)("inlineCode",{parentName:"p"},"@app()"),". Do this if you plan to host exactly one app and nothing else."),Object(o.b)("p",null,"You can host multiple apps behind a single Wave server."),Object(o.b)("div",{className:"admonition admonition-caution alert alert--warning"},Object(o.b)("div",Object(a.a)({parentName:"div"},{className:"admonition-heading"}),Object(o.b)("h5",{parentName:"div"},Object(o.b)("span",Object(a.a)({parentName:"h5"},{className:"admonition-icon"}),Object(o.b)("svg",Object(a.a)({parentName:"span"},{xmlns:"http://www.w3.org/2000/svg",width:"16",height:"16",viewBox:"0 0 16 16"}),Object(o.b)("path",Object(a.a)({parentName:"svg"},{fillRule:"evenodd",d:"M8.893 1.5c-.183-.31-.52-.5-.887-.5s-.703.19-.886.5L.138 13.499a.98.98 0 0 0 0 1.001c.193.31.53.501.886.501h13.964c.367 0 .704-.19.877-.5a1.03 1.03 0 0 0 .01-1.002L8.893 1.5zm.133 11.497H6.987v-2.003h2.039v2.003zm0-3.004H6.987V5.987h2.039v4.006z"})))),"caution")),Object(o.b)("div",Object(a.a)({parentName:"div"},{className:"admonition-content"}),Object(o.b)("p",{parentName:"div"},Object(o.b)("inlineCode",{parentName:"p"},"/foo")," and ",Object(o.b)("inlineCode",{parentName:"p"},"/foo/bar")," are two distinct paths. ",Object(o.b)("inlineCode",{parentName:"p"},"/foo/bar")," is not interpreted as a sub-path of ",Object(o.b)("inlineCode",{parentName:"p"},"/foo"),"."))),Object(o.b)("h2",{id:"hash-routing"},"Hash routing"),Object(o.b)("p",null,"Wave apps support ",Object(o.b)("em",{parentName:"p"},"hash routing"),", a popular client-side mechanism where the location hash (the ",Object(o.b)("inlineCode",{parentName:"p"},"baz/qux")," in ",Object(o.b)("inlineCode",{parentName:"p"},"/foo/bar#baz/qux"),") can be used to decide which part of the UI to display."),Object(o.b)("h3",{id:"setting-the-location-hash"},"Setting the location hash"),Object(o.b)("p",null,"To set the location hash, prefix ",Object(o.b)("inlineCode",{parentName:"p"},"#")," to the ",Object(o.b)("inlineCode",{parentName:"p"},"name")," attribute of command-like components. When the command is invoked, the location hash is set to the name of the command."),Object(o.b)("p",null,"For example, if a button is named ",Object(o.b)("inlineCode",{parentName:"p"},"foo")," is clicked, ",Object(o.b)("inlineCode",{parentName:"p"},"q.args.foo")," is set to ",Object(o.b)("inlineCode",{parentName:"p"},"True"),". Instead, if a button named ",Object(o.b)("inlineCode",{parentName:"p"},"#foo")," is clicked, the location hash is set to ",Object(o.b)("inlineCode",{parentName:"p"},"foo")," (",Object(o.b)("inlineCode",{parentName:"p"},"q.args.foo")," is not set). "),Object(o.b)("pre",null,Object(o.b)("code",Object(a.a)({parentName:"pre"},{className:"language-py",metastring:"{8-9}","{8-9}":!0}),"from h2o_wave import Q, main, app, ui\n\n@app('/toss')\nasync def serve(q: Q):\n    q.page['sides'] = ui.form_card(\n        box='1 1 4 4',\n        items=[\n            ui.button(name='#heads', label='Heads'),\n            ui.button(name='#tails', label='Tails'),\n        ],\n    )\n    await q.page.save()\n")),Object(o.b)("p",null,"Names don't have to be alphanumeric, so you can use names with nested sub-paths like ",Object(o.b)("inlineCode",{parentName:"p"},"#foo/bar"),", ",Object(o.b)("inlineCode",{parentName:"p"},"#foo/bar/baz"),", ",Object(o.b)("inlineCode",{parentName:"p"},"#foo/bar/baz/qux")," to make route-handling more manageable."),Object(o.b)("p",null,"The components that support setting a location hash are:"),Object(o.b)("ul",null,Object(o.b)("li",{parentName:"ul"},Object(o.b)("inlineCode",{parentName:"li"},"ui.button()")),Object(o.b)("li",{parentName:"ul"},Object(o.b)("inlineCode",{parentName:"li"},"ui.command()")),Object(o.b)("li",{parentName:"ul"},Object(o.b)("inlineCode",{parentName:"li"},"ui.nav_item()")),Object(o.b)("li",{parentName:"ul"},Object(o.b)("inlineCode",{parentName:"li"},"ui.tab()")),Object(o.b)("li",{parentName:"ul"},Object(o.b)("inlineCode",{parentName:"li"},"ui.breadcrumb()"))),Object(o.b)("h3",{id:"getting-the-location-hash"},"Getting the location hash"),Object(o.b)("p",null,"To get the location hash, read ",Object(o.b)("inlineCode",{parentName:"p"},"q.args['#']")," (a string). If the route in the browser's address bar is ",Object(o.b)("inlineCode",{parentName:"p"},"/foo/bar#baz/qux"),", ",Object(o.b)("inlineCode",{parentName:"p"},"q.args['#']")," is set to ",Object(o.b)("inlineCode",{parentName:"p"},"baz/qux"),"."),Object(o.b)("pre",null,Object(o.b)("code",Object(a.a)({parentName:"pre"},{className:"language-py",metastring:"{5-9}","{5-9}":!0}),"from h2o_wave import Q, main, app, ui\n\n@app('/toss')\nasync def serve(q: Q):\n    hash = q.args['#']\n    if hash == 'heads':\n        print('Heads!')\n    elif hash == 'tails':\n        print('Tails!')\n\n    q.page.save()\n")),Object(o.b)("h3",{id:"hash-route-switching"},"Hash route switching"),Object(o.b)("p",null,"Combining the two examples above gives us a basic pattern for handling routes and updating the user interface:"),Object(o.b)("pre",null,Object(o.b)("code",Object(a.a)({parentName:"pre"},{className:"language-py",metastring:"{7,9,11}","{7,9,11}":!0}),"from h2o_wave import Q, main, app, ui\n\n@app('/toss')\nasync def serve(q: Q):\n    hash = q.args['#']\n\n    if hash == 'heads':\n        q.page['sides'].items = [ui.message_bar(text='Heads!')]\n    elif hash == 'tails':\n        q.page['sides'].items = [ui.message_bar(text='Tails!')]\n    else:\n        q.page['sides'] = ui.form_card(\n            box='1 1 4 4',\n            items=[\n                ui.button(name='#heads', label='Heads'),\n                ui.button(name='#tails', label='Tails'),\n            ],\n        )\n\n    await q.page.save()\n")),Object(o.b)("h3",{id:"organizing-code"},"Organizing code"),Object(o.b)("p",null,"In most sizeable applications, the logic in the above ",Object(o.b)("inlineCode",{parentName:"p"},"if/elif/else")," conditionals can call into sub-functions, possibly spread across other modules:"),Object(o.b)("pre",null,Object(o.b)("code",Object(a.a)({parentName:"pre"},{className:"language-py",metastring:"{23,25,27}","{23,25,27}":!0}),"from h2o_wave import Q, main, app, ui\n\nasync def on_heads(q: Q):\n    q.page['sides'].items = [ui.message_bar(text='Heads!')]\n\nasync def on_heads(q: Q):\n    q.page['sides'].items = [ui.message_bar(text='Tails!')]\n\nasync def setup_page(q: Q):\n    q.page['sides'] = ui.form_card(\n        box='1 1 4 4',\n        items=[\n            ui.button(name='#heads', label='Heads'),\n            ui.button(name='#tails', label='Tails'),\n        ],\n    )\n\n@app('/toss')\nasync def serve(q: Q):\n    hash = q.args['#']\n\n    if hash == 'heads':\n        await on_heads(q)\n    elif hash == 'tails':\n        await on_tails(q)\n    else:\n        await setup_page(q)\n\n    await q.page.save()\n")),Object(o.b)("h3",{id:"reducing-boilerplate"},"Reducing boilerplate"),Object(o.b)("p",null,"As your application gets larger, using the above ",Object(o.b)("inlineCode",{parentName:"p"},"if/elif/else")," conditionals can seem tedious or repetitive. If so, you can use ",Object(o.b)("inlineCode",{parentName:"p"},"on")," and ",Object(o.b)("inlineCode",{parentName:"p"},"handle_on")," to reduce the boilerplate."),Object(o.b)("pre",null,Object(o.b)("code",Object(a.a)({parentName:"pre"},{className:"language-py",metastring:"{3,7,22}","{3,7,22}":!0}),"from h2o_wave import Q, main, app, ui, on, handle_on\n\n@on('#heads')\nasync def on_heads(q: Q):\n    q.page['sides'].items = [ui.message_bar(text='Heads!')]\n\n@on('#tails')\nasync def on_heads(q: Q):\n    q.page['sides'].items = [ui.message_bar(text='Tails!')]\n\nasync def setup_page(q: Q):\n    q.page['sides'] = ui.form_card(\n        box='1 1 4 4',\n        items=[\n            ui.button(name='#heads', label='Heads'),\n            ui.button(name='#tails', label='Tails'),\n        ],\n    )\n\n@app('/toss')\nasync def serve(q: Q):\n    if not await handle_on(q):\n        await setup_page(q)\n\n    await q.page.save()\n")),Object(o.b)("p",null,"In the above example, the ",Object(o.b)("inlineCode",{parentName:"p"},"@on('#heads')"),' is read as "if ',Object(o.b)("inlineCode",{parentName:"p"},"q.args['#']")," is ",Object(o.b)("inlineCode",{parentName:"p"},"'heads'"),", then invoke the function the ",Object(o.b)("inlineCode",{parentName:"p"},"@on()"),' is applied to" - in this case, ',Object(o.b)("inlineCode",{parentName:"p"},"on_heads()"),"."),Object(o.b)("h3",{id:"pattern-matching"},"Pattern matching"),Object(o.b)("p",null,"The ",Object(o.b)("inlineCode",{parentName:"p"},"@on()")," annotation supports pattern matching."),Object(o.b)("p",null,"This function is called when ",Object(o.b)("inlineCode",{parentName:"p"},"q.args['#'] == 'menu'"),":"),Object(o.b)("pre",null,Object(o.b)("code",Object(a.a)({parentName:"pre"},{className:"language-py"}),"@on('#menu')\nasync def show_menu(q: Q):\n    pass\n")),Object(o.b)("p",null,"This function is called when ",Object(o.b)("inlineCode",{parentName:"p"},"q.args['#'] == 'menu/donuts'"),":"),Object(o.b)("pre",null,Object(o.b)("code",Object(a.a)({parentName:"pre"},{className:"language-py"}),"@on('#menu/donuts')\nasync def show_donuts(q: Q):\n    pass\n")),Object(o.b)("p",null,"This function is called when ",Object(o.b)("inlineCode",{parentName:"p"},"q.args['#']")," matches, say, 'menu/donuts/chocolate', with the parameter ",Object(o.b)("inlineCode",{parentName:"p"},"donut_name")," set to 'chocolate':"),Object(o.b)("pre",null,Object(o.b)("code",Object(a.a)({parentName:"pre"},{className:"language-py"}),"@on('#menu/donuts/{donut_name}')\nasync def show_donut(q: Q, donut_name: str):\n    pass\n")),Object(o.b)("p",null,"Same as above, but ",Object(o.b)("inlineCode",{parentName:"p"},"donut_name")," is explicitly set to a string:"),Object(o.b)("pre",null,Object(o.b)("code",Object(a.a)({parentName:"pre"},{className:"language-py"}),"@on('#menu/donuts/{donut_name:str}')\nasync def show_donut(q: Q, donut_name: str):\n    pass\n")),Object(o.b)("p",null,"This function is called when ",Object(o.b)("inlineCode",{parentName:"p"},"q.args['#']")," matches, say, 'menu/donuts/42',  with the parameter ",Object(o.b)("inlineCode",{parentName:"p"},"donut_id")," set to 42:"),Object(o.b)("pre",null,Object(o.b)("code",Object(a.a)({parentName:"pre"},{className:"language-py"}),"@on('#menu/donuts/{donut_id:int}')\nasync def show_donut(q: Q, donut_id: int):\n    pass\n")),Object(o.b)("p",null,"This function is called when ",Object(o.b)("inlineCode",{parentName:"p"},"q.args['#']")," matches, say, 'menu/donuts/7e21c93f-3a8f-4994-b63e-4275bc975e60', with the parameter ",Object(o.b)("inlineCode",{parentName:"p"},"donut_id")," set to the UUID:"),Object(o.b)("pre",null,Object(o.b)("code",Object(a.a)({parentName:"pre"},{className:"language-py"}),"@on('#menu/donuts/{donut_id:uuid}')\nasync def show_donut(q: Q, donut_id: uuid.UUID):\n    pass\n")),Object(o.b)("p",null,"This function is called when ",Object(o.b)("inlineCode",{parentName:"p"},"q.args['#']")," matches, say, 'menu/donuts/below/2.99', with the parameter ",Object(o.b)("inlineCode",{parentName:"p"},"donut_price")," set to 2.99:"),Object(o.b)("pre",null,Object(o.b)("code",Object(a.a)({parentName:"pre"},{className:"language-py"}),"@on('#menu/donuts/below/{donut_price:float}')\nasync def show_donuts_below(q: Q, donut_price: float):\n    pass\n")))}b.isMDXComponent=!0},305:function(e,n,t){"use strict";t.d(n,"a",(function(){return l})),t.d(n,"b",(function(){return m}));var a=t(0),i=t.n(a);function o(e,n,t){return n in e?Object.defineProperty(e,n,{value:t,enumerable:!0,configurable:!0,writable:!0}):e[n]=t,e}function s(e,n){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var a=Object.getOwnPropertySymbols(e);n&&(a=a.filter((function(n){return Object.getOwnPropertyDescriptor(e,n).enumerable}))),t.push.apply(t,a)}return t}function r(e){for(var n=1;n<arguments.length;n++){var t=null!=arguments[n]?arguments[n]:{};n%2?s(Object(t),!0).forEach((function(n){o(e,n,t[n])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):s(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))}))}return e}function p(e,n){if(null==e)return{};var t,a,i=function(e,n){if(null==e)return{};var t,a,i={},o=Object.keys(e);for(a=0;a<o.length;a++)t=o[a],n.indexOf(t)>=0||(i[t]=e[t]);return i}(e,n);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(a=0;a<o.length;a++)t=o[a],n.indexOf(t)>=0||Object.prototype.propertyIsEnumerable.call(e,t)&&(i[t]=e[t])}return i}var c=i.a.createContext({}),b=function(e){var n=i.a.useContext(c),t=n;return e&&(t="function"==typeof e?e(n):r(r({},n),e)),t},l=function(e){var n=b(e.components);return i.a.createElement(c.Provider,{value:n},e.children)},d={inlineCode:"code",wrapper:function(e){var n=e.children;return i.a.createElement(i.a.Fragment,{},n)}},u=i.a.forwardRef((function(e,n){var t=e.components,a=e.mdxType,o=e.originalType,s=e.parentName,c=p(e,["components","mdxType","originalType","parentName"]),l=b(t),u=a,m=l["".concat(s,".").concat(u)]||l[u]||d[u]||o;return t?i.a.createElement(m,r(r({ref:n},c),{},{components:t})):i.a.createElement(m,r({ref:n},c))}));function m(e,n){var t=arguments,a=n&&n.mdxType;if("string"==typeof e||a){var o=t.length,s=new Array(o);s[0]=u;var r={};for(var p in n)hasOwnProperty.call(n,p)&&(r[p]=n[p]);r.originalType=e,r.mdxType="string"==typeof e?e:a,s[1]=r;for(var c=2;c<o;c++)s[c]=t[c];return i.a.createElement.apply(null,s)}return i.a.createElement.apply(null,t)}u.displayName="MDXCreateElement"}}]);